/*
 * Created on 2019-08-18 ( Time 17:15:13 )
 * Generated by Telosys Tools Generator ( version 3.0.0 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.diaspora.star.motors.sarl.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;

import javax.persistence.*;

/**
 * Persistent class for entity stored in table "panne_declaree_ordre_reparation"
 *
 * @author Telosys Tools Generator
 *
 */

@Entity
@Table(name="panne_declaree_ordre_reparation" )
public class PanneDeclareeOrdreReparation implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="observations")
    private String     observations ;

	/*
	 * 
	 */
    @Column(name="diagnostic_atelier")
    private String     diagnosticAtelier ;

	/*
	 * 
	 */
    @Column(name="is_declared_by_client")
    private Boolean    isDeclaredByClient ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	// "panneDeclareeId" (column "panne_declaree_id") is not defined by itself because used as FK in a link 
	// "ordreReparationId" (column "ordre_reparation_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="ordre_reparation_id", referencedColumnName="id")
    private OrdreReparation ordreReparation;
    @ManyToOne
    @JoinColumn(name="panne_declaree_id", referencedColumnName="id")
    private PanneDeclaree panneDeclaree;

    //----------------------------------------------------------------------
    // CONSTRUCTOR(S)
    //----------------------------------------------------------------------
    public PanneDeclareeOrdreReparation() {
		super();
    }
    
    //----------------------------------------------------------------------
    // GETTER & SETTER FOR THE KEY FIELD
    //----------------------------------------------------------------------
    public void setId( Integer id ) {
        this.id = id ;
    }
    public Integer getId() {
        return this.id;
    }

    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR FIELDS
    //----------------------------------------------------------------------
    //--- DATABASE MAPPING : observations ( TEXT ) 
    public void setObservations( String observations ) {
        this.observations = observations;
    }
    public String getObservations() {
        return this.observations;
    }

    //--- DATABASE MAPPING : diagnostic_atelier ( TEXT ) 
    public void setDiagnosticAtelier( String diagnosticAtelier ) {
        this.diagnosticAtelier = diagnosticAtelier;
    }
    public String getDiagnosticAtelier() {
        return this.diagnosticAtelier;
    }

    //--- DATABASE MAPPING : is_declared_by_client ( BIT ) 
    public void setIsDeclaredByClient( Boolean isDeclaredByClient ) {
        this.isDeclaredByClient = isDeclaredByClient;
    }
    public Boolean getIsDeclaredByClient() {
        return this.isDeclaredByClient;
    }

    //--- DATABASE MAPPING : is_deleted ( BIT ) 
    public void setIsDeleted( Boolean isDeleted ) {
        this.isDeleted = isDeleted;
    }
    public Boolean getIsDeleted() {
        return this.isDeleted;
    }

    //--- DATABASE MAPPING : created_at ( DATETIME ) 
    public void setCreatedAt( Date createdAt ) {
        this.createdAt = createdAt;
    }
    public Date getCreatedAt() {
        return this.createdAt;
    }

    //--- DATABASE MAPPING : updated_at ( DATETIME ) 
    public void setUpdatedAt( Date updatedAt ) {
        this.updatedAt = updatedAt;
    }
    public Date getUpdatedAt() {
        return this.updatedAt;
    }

    //--- DATABASE MAPPING : deleted_at ( DATETIME ) 
    public void setDeletedAt( Date deletedAt ) {
        this.deletedAt = deletedAt;
    }
    public Date getDeletedAt() {
        return this.deletedAt;
    }

    //--- DATABASE MAPPING : created_by ( INT ) 
    public void setCreatedBy( Integer createdBy ) {
        this.createdBy = createdBy;
    }
    public Integer getCreatedBy() {
        return this.createdBy;
    }

    //--- DATABASE MAPPING : updated_by ( INT ) 
    public void setUpdatedBy( Integer updatedBy ) {
        this.updatedBy = updatedBy;
    }
    public Integer getUpdatedBy() {
        return this.updatedBy;
    }

    //--- DATABASE MAPPING : deleted_by ( INT ) 
    public void setDeletedBy( Integer deletedBy ) {
        this.deletedBy = deletedBy;
    }
    public Integer getDeletedBy() {
        return this.deletedBy;
    }


    //----------------------------------------------------------------------
    // GETTERS & SETTERS FOR LINKS
    //----------------------------------------------------------------------

    public void setOrdreReparation( OrdreReparation ordreReparation ) {
        this.ordreReparation = ordreReparation;
    }
    public OrdreReparation getOrdreReparation() {
        return this.ordreReparation;
    }


    public void setPanneDeclaree( PanneDeclaree panneDeclaree ) {
        this.panneDeclaree = panneDeclaree;
    }
    public PanneDeclaree getPanneDeclaree() {
        return this.panneDeclaree;
    }


    //----------------------------------------------------------------------
    // toString METHOD
    //----------------------------------------------------------------------
    public String toString() { 
        StringBuffer sb = new StringBuffer(); 
        sb.append("["); 
        sb.append(id);
        sb.append("]:"); 
        // attribute 'observations' not usable (type = String Long Text)
        // attribute 'diagnosticAtelier' not usable (type = String Long Text)
        sb.append(isDeclaredByClient);
        sb.append("|");
        sb.append(isDeleted);
        sb.append("|");
        sb.append(createdAt);
        sb.append("|");
        sb.append(updatedAt);
        sb.append("|");
        sb.append(deletedAt);
        sb.append("|");
        sb.append(createdBy);
        sb.append("|");
        sb.append(updatedBy);
        sb.append("|");
        sb.append(deletedBy);
        return sb.toString(); 
    } 

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
